#include <csignal>
//a Sandbox to play arroung
#ifdef WIN32
#include <windows.h>
#define SER_PORT "\\\\.\\COM35"  //COM4
#else
#define SER_PORT "/dev/ttyUSB0"//! the Serial Port Device
#endif


#define LOAD_CONFIG "./learned.txt" //! where to store the gateway Configuration
#define LEARN_TIME_S 1 //! allows you to set the time the gateway should stay in learnmode
#include "eoLink.h"
#include "./Profiles/eoF6EEProfile.h"
#include <stdio.h>

#define	ROCKER_STATE_I 0
#define	ROCKER_STATE_O 1
#define	ROCKER_STATE_NP 2

int win32Test()
{
	setvbuf(stdout, NULL, _IONBF, 0);
	setvbuf(stderr, NULL, _IONBF, 0);
	//First a Gateway and a storageManager will be definied
	eoGateway myGateway;
	eoSerialCommand ser(&myGateway);

	printf("Opening Connection to USB300 \n");
	if (myGateway.Open(SER_PORT)!=EO_OK)
	{
		printf("Failed to open USB300\n");
		return 0;
	}

	CO_RD_VERSION_RESPONSE version;
	if (ser.ReadVersion(version) == EO_OK)
	{
		printf("%s %i.%i.%i.%i, ID:0x%08X on %s\n",
								   version.appDescription,
								   version.appVersion[0], version.appVersion[1], version.appVersion[2], version.appVersion[3],
								   version.chipID,
								   SER_PORT);
	}
	//Failed to read the version of the device
	else
	{
		printf("Failed to retrieve USB300 version\n");
		return 0;
	}
	eoTimer::Sleep(1000);
	printf("EnOcean-Link Gateway LearnMode\n");
	//adding a dBm Filter as learnFilter


	//the eoIDFilter will allow our Gateway application to filter all the unwanted Telegrams
	eoIDFilter * myFilter = new eoIDFilter();
	myGateway.filter=myFilter;

	//recv stores the return Value of the Gateway
	uint16_t recv;
	//As RPS Telegrams don't have a teach IN Telegram, we need to set the wished profiled for an automated Teach IN
	myGateway.TeachInModule->Set1BS(0x00, 0x01);
	myGateway.TeachInModule->Set4BS(0x12, 0x04);
	myGateway.TeachInModule->SetRPS(0x02,0x01);
	//Set the learnTime and update the time
	//Activate LearnMode
	myGateway.LearnMode=true;

	uint32_t const endTime = eoTimer::GetTickCount() + 1000*60*60*24*3;//*60*24;
	while(endTime>eoTimer::GetTickCount())
	{

		recv = myGateway.Receive();
		if (recv & RECV_TELEGRAM)
		{
			eoDebug::Print(myGateway.telegram);
		}

		if ((recv & RECV_TEACHIN))
		{
			eoProfile *profile = myGateway.device->GetProfile();
			printf("Device %08X Learned-In EEP: %02X-%02X-%02X\n", myGateway.device->ID, profile->rorg, profile->func, profile->type );


			for (int i = 0; i<profile->GetChannelCount(); i++)
			{
				printf("%s %.2f ... %.2f %s\n", profile->GetChannel(i)->ToString(NAME), profile->GetChannel(i)->min, profile->GetChannel(i)->max, profile->GetChannel(i)->ToString(UNIT));
			}

		}

		if (recv & RECV_PROFILE)
		{
			printf("Device %08X\n", myGateway.device->ID);
			eoProfile *profile = myGateway.device->GetProfile();

			float f;
			uint8_t t;
			for (int i = 0; i<profile->GetChannelCount(); i++)
			{
				if (profile->GetValue( profile->GetChannel(i)->type, f) ==EO_OK)
					printf("%s %.2f %s\n", profile->GetChannel(i)->ToString(NAME),f,profile->GetChannel(i)->ToString(UNIT));
				if (profile->GetValue( profile->GetChannel(i)->type, t) ==EO_OK)
									printf("%s %u \n", profile->GetChannel(i)->ToString(NAME),t);

			}
		}
	}
	return 0;
}

int main(int argc, const char* argv[])
{
	win32Test();
}

